
package javaapplication1;

import java.awt.Color;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;


/**
 *
 * @author Zdenek
 */
public class Win extends javax.swing.JFrame {

    /** Creates new form NewJFrame */
    public Win() {
        initComponents();
    }

    public void paint(java.awt.Graphics g)
    {
         java.awt.Graphics2D g2 = (java.awt.Graphics2D) g;
         g.setColor(Color.blue);
         g.fillRect (10, 100, 200, 100);
         g.setColor(Color.yellow);
         g.drawRect(10, 100, 200, 100);
    }

    // http://www.java3d.org/czech.html
    // http://en.wikipedia.org/wiki/Java_3D
    // https://java3d.dev.java.net/
    // download https://java3d.dev.java.net/binary-builds.html

    public void cube()
    {
		SimpleUniverse universe = new SimpleUniverse();
		BranchGroup group = new BranchGroup();
		group.addChild(new ColorCube(0.3));
		universe.getViewingPlatform().setNominalViewingTransform();
		universe.addBranchGraph(group);
    }

    public void ball()
    {          
                // Vytvoříme vesmír
		SimpleUniverse universe = new SimpleUniverse();

	    	// Vytvoříme strukturu obsahující objekty
		BranchGroup group = new BranchGroup();

	    	// Vytvoříme kouli a přidáme ji do skupiny objektů
		Sphere sphere = new Sphere(0.5f);
    		group.addChild(sphere);

	    	// Vytvoříme červené světlo svítící 100m od počátku
    		Color3f light1Color = new Color3f(1.8f, 0.1f, 0.1f);
    		BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
		Vector3f light1Direction  = new Vector3f(4.0f, -7.0f, -12.0f);
    		DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);
    		light1.setInfluencingBounds(bounds);
    		group.addChild(light1);

    		// Nastavíme pohled na kouli
	    	universe.getViewingPlatform().setNominalViewingTransform();

	    	// Vložíme skupinu s objekty do vesmíru
    		universe.addBranchGraph(group);
    }

    public void position()
    {
    		SimpleUniverse universe = new SimpleUniverse();
    		BranchGroup group = new BranchGroup();
		// Osa x vyrobená z koulí
    		for (float x = -1.0f; x <= 1.0f; x = x + 0.1f) {
		        Sphere sphere = new Sphere(0.05f);
		        TransformGroup tg = new TransformGroup();
		        Transform3D transform = new Transform3D();
		        Vector3f vector = new Vector3f( x, .0f, .0f);
			transform.setTranslation(vector);
		        tg.setTransform(transform);
		        tg.addChild(sphere);
		        group.addChild(tg);
		}
    		// Osa Y vyrobená z kuželů
		for (float y = -1.0f; y <= 1.0f; y = y + 0.1f) {
	        	TransformGroup tg = new TransformGroup();
		        Transform3D transform = new Transform3D();
		        Cone cone = new Cone(0.05f, 0.1f);
		        Vector3f vector = new Vector3f(.0f, y, .0f);
		        transform.setTranslation(vector);
        		tg.setTransform(transform);
		        tg.addChild(cone);
		        group.addChild(tg);
		}
    		// Osa Z vyrobená z válců
		for (float z = -1.0f; z <= 1.0f; z = z+ 0.1f) {
		        TransformGroup tg = new TransformGroup();
		        Transform3D transform = new Transform3D();
		        Cylinder cylinder = new Cylinder(0.05f, 0.1f);
		        Vector3f vector = new Vector3f(.0f, .0f, z);
		        transform.setTranslation(vector);
		        tg.setTransform(transform);
		        tg.addChild(cylinder);
		        group.addChild(tg);
		}

	    	Color3f light1Color = new Color3f(.1f, 1.4f, .1f);
   		BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
    		Vector3f light1Direction  = new Vector3f(4.0f, -7.0f, -12.0f);
    		DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);
    		light1.setInfluencingBounds(bounds);
    		group.addChild(light1);
    		universe.getViewingPlatform().setNominalViewingTransform();

	    	// Vložíme skupinu transformací do vesmíru
    		universe.addBranchGraph(group);
    }



    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
                formCaretPositionChanged(evt);
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
            }
        });

        jButton1.setText("jButton1");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addContainerGap(618, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(14, 14, 14)
                .addComponent(jButton1)
                .addContainerGap(435, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        position ();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void formCaretPositionChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_formCaretPositionChanged
        // TODO add your handling code here:
    }//GEN-LAST:event_formCaretPositionChanged

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Win().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    // End of variables declaration//GEN-END:variables

}
